## orcania 2.1.1

=== CMakeLists.txt ===
#
# Orcania library
#
# CMake file used to build all programs
#
# Copyright 2018 Silvio Clecio <silvioprog@gmail.com>
# Copyright 2018-2020 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the MIT License
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#

cmake_minimum_required(VERSION 3.5)

project(orcania C)

set(CMAKE_C_STANDARD 99)
if (NOT MSVC)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Werror")
endif()

# library info

set(PROJECT_DESCRIPTION "Potluck with different functions for different purposes that can be shared among programs")
set(PROJECT_HOMEPAGE_URL "https://github.com/babelouest/orcania/")
set(PROJECT_BUGREPORT_PATH "https://github.com/babelouest/orcania/issues")
set(LIBRARY_VERSION_MAJOR "2")
set(LIBRARY_VERSION_MINOR "1")
set(LIBRARY_VERSION_PATCH "1")
set(LIBS "-lm")

set(PROJECT_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
set(PROJECT_VERSION_MAJOR ${LIBRARY_VERSION_MAJOR})
set(PROJECT_VERSION_MINOR ${LIBRARY_VERSION_MINOR})
set(PROJECT_VERSION_PATCH ${LIBRARY_VERSION_PATCH})

if (${LIBRARY_VERSION_MAJOR} VERSION_LESS 10)
    set (LIBRARY_VERSION_MAJOR_PAD "0${LIBRARY_VERSION_MAJOR}")
else ()
    set (LIBRARY_VERSION_MAJOR_PAD "${LIBRARY_VERSION_MAJOR}")
endif ()
if (${LIBRARY_VERSION_MINOR} VERSION_LESS 10)
    set (LIBRARY_VERSION_MINOR_PAD "0${LIBRARY_VERSION_MINOR}")
else ()
    set (LIBRARY_VERSION_MINOR_PAD "${LIBRARY_VERSION_MINOR}")
endif ()
if (${LIBRARY_VERSION_PATCH} VERSION_LESS 10)
    set (LIBRARY_VERSION_PATCH_PAD "0${LIBRARY_VERSION_PATCH}")
else ()
    set (LIBRARY_VERSION_PATCH_PAD "${LIBRARY_VERSION_PATCH}")
endif ()
set(PROJECT_VERSION_NUMBER "${LIBRARY_VERSION_MAJOR_PAD}${LIBRARY_VERSION_MINOR_PAD}${LIBRARY_VERSION_PATCH_PAD}")

set(LIBRARY_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
set(LIBRARY_SOVERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}")

# cmake modules

set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake-modules)

include(GNUInstallDirs)
include(CheckSymbolExists)

# check if _GNU_SOURCE is available

if (NOT _GNU_SOURCE)
    check_symbol_exists(__GNU_LIBRARY__ "features.h" _GNU_SOURCE)

    if (NOT _GNU_SOURCE)
        unset(_GNU_SOURCE CACHE)
        check_symbol_exists(_GNU_SOURCE "features.h" _GNU_SOURCE)
    endif ()
endif ()

if (_GNU_SOURCE)
    add_definitions(-D_GNU_SOURCE)
endif ()

# directories and source

set(INC_DIR ${CMAKE_CURRENT_SOURCE_DIR}/include)
set(SRC_DIR ${CMAKE_CURRENT_SOURCE_DIR}/src)

include_directories(${INC_DIR})

set(LIB_SRC
        ${INC_DIR}/orcania.h # allow many IDEs to find and edit it
        ${SRC_DIR}/base64.c
        ${SRC_DIR}/memory.c
        ${SRC_DIR}/orcania.c)

option(WITH_STRSTR "Use inline implementation of strstr" OFF)
if (WITH_STRSTR)
    set(O_STRSTR ON)
else ()
    set(O_STRSTR OFF)
endif ()

set(PKGCONF_REQ "")
set(PKGCONF_REQ_PRIVATE "")

# build orcania-cfg.h file
configure_file(${INC_DIR}/orcania-cfg.h.in ${PROJECT_BINARY_DIR}/orcania-cfg.h)
set (CMAKE_EXTRA_INCLUDE_FILES ${PROJECT_BINARY_DIR})
include_directories(${PROJECT_BINARY_DIR})

# static library

option(BUILD_STATIC "Build static library." OFF)

if (BUILD_STATIC)
    add_library(orcania_static STATIC ${LIB_SRC})
    target_compile_definitions(orcania_static PUBLIC -DO_STATIC_LIBRARY)
    set_target_properties(orcania_static PROPERTIES
            OUTPUT_NAME orcania)
endif ()

# shared library

add_library(orcania SHARED ${LIB_SRC})
if (NOT MSVC)
    set_target_properties(orcania PROPERTIES
            COMPILE_OPTIONS -Wextra
            PUBLIC_HEADER "${INC_DIR}/orcania.h;${PROJECT_BINARY_DIR}/orcania-cfg.h"
            VERSION "${LIBRARY_VERSION}"
            SOVERSION "${LIBRARY_SOVERSION}")
endif()
if (WIN32)
    set_target_properties(orcania PROPERTIES SUFFIX "-${LIBRARY_VERSION_MAJOR}.dll")
endif ()
target_link_libraries(orcania ${LIBS})

# documentation

option(BUILD_ORCANIA_DOCUMENTATION "Build the documentation." OFF)
if (BUILD_ORCANIA_DOCUMENTATION)
    find_package(Doxygen)
    if (DOXYGEN_FOUND)
        set(doxyfile_in ${CMAKE_CURRENT_SOURCE_DIR}/doc/doxygen.cfg)
        set(doxyfile ${CMAKE_CURRENT_BINARY_DIR}/doxyfile)
        
        configure_file(${doxyfile_in} ${doxyfile} @ONLY)
        
        add_custom_target(doc
                          COMMAND ${DOXYGEN_EXECUTABLE} ${doxyfile_in}
                          WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
                          COMMENT "Generating documentation with Doxygen"
                          VERBATIM)

    else ()
        message(FATAL_ERROR "Doxygen is needed to build the documentation.")
    endif ()
endif ()

# tests

option(BUILD_ORCANIA_TESTING "Build the testing tree." OFF) # because we do not use include(CTest)

if (BUILD_ORCANIA_TESTING)
    include(FindCheck)
    find_package(Check)
    if (CHECK_FOUND)
        if (NOT WIN32 AND NOT APPLE)
            include(FindSubunit)
            find_package(Subunit REQUIRED)
        endif ()

        enable_testing()

        set(CMAKE_CTEST_COMMAND ctest -V)

        set(TST_DIR ${CMAKE_CURRENT_SOURCE_DIR}/test)
        set(LIBS orcania ${LIBS} ${CHECK_LIBRARIES})
        if (NOT WIN32)
            find_package(Threads REQUIRED)
            set(LIBS ${LIBS} ${CMAKE_THREAD_LIBS_INIT} m)
        endif ()
        if (NOT APPLE)
            set(LIBS ${LIBS} rt)
        endif ()
        if (NOT WIN32 AND NOT APPLE)
            set(LIBS ${LIBS} ${SUBUNIT_LIBRARIES} rt)
        endif ()

        set(TESTS
                str_test
                split_test
                memory_test
                pointer_list_test)

        configure_file(
                "${CMAKE_MODULE_PATH}/CTestCustom.cmake.in"
                "${CMAKE_CURRENT_BINARY_DIR}/CTestCustom.cmake"
                @ONLY)

        foreach (t ${TESTS})
            add_executable(${t} EXCLUDE_FROM_ALL ${TST_DIR}/${t}.c)
            target_include_directories(${t} PUBLIC ${TST_DIR})
            target_link_libraries(${t} PUBLIC ${LIBS})
            add_test(NAME ${t}
                    WORKING_DIRECTORY ${TST_DIR}
                    COMMAND ${t})
        endforeach ()
    endif ()
endif ()

# install target

option(INSTALL_HEADER "Install the header files" ON) # Install orcania.h or not

configure_file(liborcania.pc.in liborcania.pc @ONLY)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/liborcania.pc
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

set(TARGETS orcania)
if (BUILD_STATIC)
    set(TARGETS ${TARGETS} orcania_static)
endif ()

if (INSTALL_HEADER)
    install(TARGETS ${TARGETS}
            RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
            LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
            ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
            PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
else ()
    install(TARGETS ${TARGETS}
            RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
            LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
            ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
endif ()

# uninstall target

if (NOT TARGET uninstall)
    configure_file(
            "${CMAKE_MODULE_PATH}/CMakeUninstall.cmake.in"
            "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
            IMMEDIATE @ONLY)
    add_custom_target(uninstall
            COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)
endif ()

# packaging

set(CPACK_PACKAGE_VERSION_MAJOR ${LIBRARY_VERSION_MAJOR})
set(CPACK_PACKAGE_VERSION_MINOR ${LIBRARY_VERSION_MINOR})
set(CPACK_PACKAGE_VERSION_PATCH ${LIBRARY_VERSION_PATCH})

if (INSTALL_HEADER)
    set(PACKAGE_FILE_NAME
            "lib${CMAKE_PROJECT_NAME}-dev_${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
else ()
    set(PACKAGE_FILE_NAME
            "lib${CMAKE_PROJECT_NAME}_${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
endif ()
set(PACKAGE_IGNORED_FILES
        "${CMAKE_CURRENT_BINARY_DIR}/;/.git/;.gitignore;~$;${CPACK_SOURCE_IGNORE_FILES}")

set(CPACK_PACKAGE_NAME "liborcania")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Potluck for C programs")
set(CPACK_GENERATOR "TGZ;DEB")
set(CPACK_PACKAGE_VERSION_MAJOR ${LIBRARY_VERSION_MAJOR})
set(CPACK_PACKAGE_VERSION_MINOR ${LIBRARY_VERSION_MINOR})
set(CPACK_PACKAGE_VERSION_PATCH ${LIBRARY_VERSION_PATCH})

option(BUILD_RPM "Build a RPM for your system" OFF)
if (BUILD_RPM)
  set(CPACK_GENERATOR "TGZ;DEB;RPM")
  set(CPACK_RPM_PACKAGE_LICENSE "LGPL")
  set(CPACK_RPM_PACKAGE_URL "http://babelouest.github.io/orcania/")
endif ()

set(CPACK_DEBIAN_PACKAGE_MAINTAINER "mail@babelouest.org")
set(CPACK_DEBIAN_PACKAGE_DESCRIPTION ${PROJECT_DESCRIPTION})
set(CPACK_DEBIAN_PACKAGE_HOMEPAGE "https://github.com/babelouest/orcania")
set(CPACK_DEBIAN_PACKAGE_DEPENDS "libc6 (>= 2.4)")
set(CPACK_PACKAGE_FILE_NAME ${PACKAGE_FILE_NAME})
set(CPACK_PACKAGE_FILE_NAME ${PACKAGE_FILE_NAME})

set(CPACK_SOURCE_GENERATOR "TGZ")
set(CPACK_SOURCE_PACKAGE_FILE_NAME ${PACKAGE_FILE_NAME})
set(CPACK_SOURCE_IGNORE_FILES ${PACKAGE_IGNORED_FILES})

include(CPack)

add_custom_target(dist_o
        COMMAND ${CMAKE_MAKE_PROGRAM} package_source)

message(STATUS "Force inline implementation of strstr: ${WITH_STRSTR}")
message(STATUS "Build static library: ${BUILD_STATIC}")
message(STATUS "Build testing tree: ${BUILD_ULFIUS_TESTING}")
message(STATUS "Install the header files: ${INSTALL_HEADER}")
message(STATUS "Build RPM package: ${BUILD_RPM}")
message(STATUS "Build documentation: ${BUILD_ORCANIA_DOCUMENTATION}")

=== Makefile ===
#
# Orcania Framework
#
# Makefile used to build all programs
#
# Copyright 2017-2020 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# as published by the Free Software Foundation;
# version 2.1 of the License.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU GENERAL PUBLIC LICENSE for more details.
#
# You should have received a copy of the GNU General Public
# License along with this library.  If not, see <http://www.gnu.org/licenses/>.
#

LIBORCANIA_LOCATION=./src
TESTS_LOCATION=./test

all: target

target:
	cd $(LIBORCANIA_LOCATION) && $(MAKE) $*

debug:
	cd $(LIBORCANIA_LOCATION) && $(MAKE) debug $*

clean:
	cd $(LIBORCANIA_LOCATION) && $(MAKE) clean
	cd $(TESTS_LOCATION) && $(MAKE) clean
	rm -rf doc/html/ doc/man/

check:
	cd $(LIBORCANIA_LOCATION) && $(MAKE) debug $*
	cd $(TESTS_LOCATION) && $(MAKE) test $*

install:
	cd $(LIBORCANIA_LOCATION) && $(MAKE) install $*

uninstall:
	cd $(LIBORCANIA_LOCATION) && $(MAKE) uninstall $*

doxygen:
	doxygen doc/doxygen.cfg

release: target

=== src/Makefile ===
#
# Orcania Library
#
# Makefile used to build the software
#
# Copyright 2014-2020 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# as published by the Free Software Foundation;
# version 2.1 of the License.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
# GNU GENERAL PUBLIC LICENSE for more details.
#
# You should have received a copy of the GNU General Public
# License along with this library.	If not, see <http://www.gnu.org/licenses/>.
#
PROJECT_NAME=orcania
PROJECT_DESCRIPTION=Potluck with different functions for different purposes that can be shared among programs
PROJECT_BUGREPORT_PATH=https://github.com/babelouest/orcania/issues
PKGCONF_REQ=
PKGCONF_REQ_PRIVATE=
DESTDIR=/usr/local
ORCANIA_INCLUDE=../include
CONFIG_TEMPLATE=$(ORCANIA_INCLUDE)/orcania-cfg.h.in
CONFIG_FILE=$(ORCANIA_INCLUDE)/orcania-cfg.h
PKGCONFIG_FILE=../liborcania.pc
PKGCONFIG_TEMPLATE=../liborcania.pc.in
CC=gcc
CFLAGS+=-c -fPIC -Wall -Werror -Wextra -I$(ORCANIA_INCLUDE) -D_REENTRANT $(ADDITIONALFLAGS) $(CPPFLAGS)
OUTPUT=liborcania.so
VERSION_MAJOR=2
VERSION_MINOR=1
VERSION_PATCH=1
OBJECTS=orcania.o memory.o base64.o
LIBS=-lc -lm

SONAME = -soname
ifeq ($(shell uname -s),Darwin)
       SONAME = -install_name
endif

ifdef STRSTRFLAG
STRSTR=1
else
STRSTR=0
endif

all: release

$(CONFIG_FILE):
	@cp $(CONFIG_TEMPLATE) $(CONFIG_FILE)
	@echo Config file $(CONFIG_FILE) generated
	@sed -i -e 's/$${PROJECT_VERSION}/$(VERSION_MAJOR).$(VERSION_MINOR).$(VERSION_PATCH)/g' $(CONFIG_FILE)        
	@sed -i -e 's/$${PROJECT_VERSION_MAJOR}/$(VERSION_MAJOR)/g' $(CONFIG_FILE)        
	@sed -i -e 's/$${PROJECT_VERSION_MINOR}/$(VERSION_MINOR)/g' $(CONFIG_FILE)        
	@sed -i -e 's/$${PROJECT_VERSION_PATCH}/$(VERSION_PATCH)/g' $(CONFIG_FILE)        
	@sed -i -e 's/$${PROJECT_VERSION_NUMBER}/$(shell printf '%02d' $(VERSION_MAJOR))$(shell printf '%02d' $(VERSION_MINOR))$(shell printf '%02d' $(VERSION_PATCH))/g' $(CONFIG_FILE)        
	@if [ "$(STRSTR)" = "1" ]; then \
		sed -i -e 's/\#cmakedefine O_STRSTR/\#define O_STRSTR/g' $(CONFIG_FILE); \
		echo "FORCE IMPLEMENT STRSTR  ENABLED"; \
	else \
		sed -i -e 's/\#cmakedefine O_STRSTR/\/* #undef O_STRSTR *\//g' $(CONFIG_FILE); \
		echo "FORCE IMPLEMENT STRSTR  DISABLED"; \
	fi

$(PKGCONFIG_FILE):
	@cp $(PKGCONFIG_TEMPLATE) $(PKGCONFIG_FILE)
	@echo Pkgconfig file $(PKGCONFIG_FILE) generated
	@sed -i -e 's#@CMAKE_INSTALL_PREFIX@#$(DESTDIR)#g' $(PKGCONFIG_FILE)
	@sed -i -e 's/@CMAKE_INSTALL_LIBDIR@/lib/g' $(PKGCONFIG_FILE)
	@sed -i -e 's/@CMAKE_INSTALL_INCLUDEDIR@/include/g' $(PKGCONFIG_FILE)
	@sed -i -e 's/@PROJECT_NAME@/$(PROJECT_NAME)/g' $(PKGCONFIG_FILE)
	@sed -i -e 's/@PROJECT_DESCRIPTION@/$(PROJECT_DESCRIPTION)/g' $(PKGCONFIG_FILE)
	@sed -i -e 's|@PROJECT_BUGREPORT_PATH@|$(PROJECT_BUGREPORT_PATH)|g' $(PKGCONFIG_FILE)
	@sed -i -e 's/@LIBRARY_VERSION@/$(VERSION_MAJOR).$(VERSION_MINOR).$(VERSION_PATCH)/g' $(PKGCONFIG_FILE)
	@sed -i -e 's/@PKGCONF_REQ@/$(PKGCONF_REQ)/g' $(PKGCONFIG_FILE)
	@sed -i -e 's/@PKGCONF_REQ_PRIVATE@/$(PKGCONF_REQ_PRIVATE)/g' $(PKGCONFIG_FILE)

liborcania.so: $(OBJECTS)
	$(CC) -shared -fPIC -Wl,$(SONAME),$(OUTPUT) -o $(OUTPUT).$(VERSION_MAJOR).$(VERSION_MINOR).$(VERSION_PATCH) $(OBJECTS) $(LIBS) $(LDFLAGS)
	ln -sf $(OUTPUT).$(VERSION_MAJOR).$(VERSION_MINOR).$(VERSION_PATCH) $(OUTPUT)

liborcania.a: $(OBJECTS)
	ar rcs liborcania.a $(OBJECTS)

%.o: %.c $(CONFIG_FILE) ../include/orcania.h
	$(CC) $(CFLAGS) $<

clean:
	rm -f *.o *.so *.a $(OUTPUT) $(OUTPUT).* $(CONFIG_FILE) $(PKGCONFIG_FILE)

install: all $(PKGCONFIG_FILE)
	install $(OUTPUT).$(VERSION_MAJOR).$(VERSION_MINOR).$(VERSION_PATCH) $(DESTDIR)/lib
	mkdir -p $(DESTDIR)/lib/pkgconfig/
	install -m644 $(PKGCONFIG_FILE) $(DESTDIR)/lib/pkgconfig/
	install -m644 ../include/orcania.h $(DESTDIR)/include
	install -m644 $(CONFIG_FILE) $(DESTDIR)/include
	-ldconfig $(DESTDIR)/lib

static-install: static
	install liborcania.a $(DESTDIR)/lib
	install -m644 $(PKGCONFIG_FILE) $(DESTDIR)/lib/pkgconfig
	install -m644 ../include/orcania.h $(DESTDIR)/include
	install -m644 $(CONFIG_FILE) $(DESTDIR)/include

uninstall:
	rm -f $(DESTDIR)/lib/$(OUTPUT) $(DESTDIR)/lib/liborcania.a
	rm -f $(DESTDIR)/lib/$(OUTPUT).*
	rm -f $(DESTDIR)/include/orcania.h
	rm -f $(DESTDIR)/include/$(CONFIG_FILE)
	rm -f $(DESTDIR)/lib/pkgconfig/$(PKGCONFIG_FILE)

debug: ADDITIONALFLAGS=-DDEBUG -g -O0

debug: liborcania.so

release: ADDITIONALFLAGS=-O3

release: liborcania.so

static-debug: ADDITIONALFLAGS=-DDEBUG -g -O0

static-debug: liborcania.a

static: ADDITIONALFLAGS=-O3

static: liborcania.a

=== test/Makefile ===
#
# Public domain, no copyright. Use at your own risk.
#

CC=gcc
CFLAGS+=-Wall -D_REENTRANT -DDEBUG -g -O0 -I$(INCLUDE_LOCATION) $(CPPFLAGS)
ORCANIA_LOCATION=../src
INCLUDE_LOCATION=../include
ORCANIA_LIBRARY=$(ORCANIA_LOCATION)/liborcania.so
LIBS=-lc -lorcania $(shell pkg-config --libs check) -L$(ORCANIA_LOCATION)
VALGRIND_COMMAND=valgrind --tool=memcheck --leak-check=full --show-leak-kinds=all

all: test

clean:
	rm -f *.o str_test split_test memory_test pointer_list_test valgrind-*.txt

liborcania.so:
	cd $(ORCANIA_LOCATION) && $(MAKE) debug

str_test: str_test.c
	$(CC) $(CFLAGS) str_test.c -o str_test $(LIBS)

test_str_test: liborcania.so str_test
	-LD_LIBRARY_PATH=$(ORCANIA_LOCATION):${LD_LIBRARY_PATH} ./str_test

split_test: split_test.c
	$(CC) $(CFLAGS) split_test.c -o split_test $(LIBS)

test_split_test: liborcania.so split_test
	-LD_LIBRARY_PATH=$(ORCANIA_LOCATION):${LD_LIBRARY_PATH} ./split_test

memory_test: memory_test.c
	$(CC) $(CFLAGS) memory_test.c -o memory_test $(LIBS)

test_memory_test: liborcania.so memory_test
	-LD_LIBRARY_PATH=$(ORCANIA_LOCATION):${LD_LIBRARY_PATH} ./memory_test

pointer_list_test: pointer_list_test.c
	$(CC) $(CFLAGS) pointer_list_test.c -o pointer_list_test $(LIBS)

test_pointer_list_test: liborcania.so pointer_list_test
	-LD_LIBRARY_PATH=$(ORCANIA_LOCATION):${LD_LIBRARY_PATH} ./pointer_list_test

test: test_str_test test_split_test test_memory_test test_pointer_list_test

check: test

memcheck: $(ORCANIA_LIBRARY) str_test split_test memory_test pointer_list_test
	-CK_FORK=no LD_LIBRARY_PATH=$(ORCANIA_LOCATION):${LD_LIBRARY_PATH} $(VALGRIND_COMMAND) ./str_test 2>valgrind-str_test.txt
	-CK_FORK=no LD_LIBRARY_PATH=$(ORCANIA_LOCATION):${LD_LIBRARY_PATH} $(VALGRIND_COMMAND) ./split_test 2>valgrind-split_test.txt
	-CK_FORK=no LD_LIBRARY_PATH=$(ORCANIA_LOCATION):${LD_LIBRARY_PATH} $(VALGRIND_COMMAND) ./memory_test 2>valgrind-memory_test.txt
	-CK_FORK=no LD_LIBRARY_PATH=$(ORCANIA_LOCATION):${LD_LIBRARY_PATH} $(VALGRIND_COMMAND) ./pointer_list_test 2>valgrind-pointer_list_test.txt

=== debian/changelog ===
orcania (2.1.1-4) unstable; urgency=medium

  * d/control: Update Standards-Version to 4.5.1 (no change)
  * d/control: add breaks/replaces liborcania1.2

 -- Nicolas Mora <babelouest@debian.org>  Fri, 25 Dec 2020 09:52:03 -0500

orcania (2.1.1-3) unstable; urgency=medium

  * upload to unstable
  * d/rules: Remove specific rules to build package for arch kfreebsd-amd64
    and kfreebsd-i386 using make instead of cmake
    Not only it didn't work, but it wasn't worth it

 -- Nicolas Mora <babelouest@debian.org>  Sun, 19 Jul 2020 19:51:12 -0400

orcania (2.1.1-2) experimental; urgency=medium

  * d/control: Remove dh-exec from builddep
  * d/rules: enable dh_install
  * d/*.install: Do not use dh-exec
  * d/copyright: clean copyright licenses
  * d/patches: remove patches, now applied upstream
  * d/rules: Add specific rules to build package for arch kfreebsd-amd64 and
    kfreebsd-i386 using make instead of cmake

 -- Nicolas Mora <babelouest@debian.org>  Sun, 19 Jul 2020 08:49:58 -0400

orcania (2.1.1-1) unstable; urgency=medium

  * New upstream release
  * d/patches: remove doc patch

 -- Nicolas Mora <nicolas@babelouest.org>  Mon, 06 Jul 2020 07:58:42 -0400

orcania (2.1.0-4) unstable; urgency=medium

  * Upload to unstable
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Remove obsolete fields Contact, Name from debian/upstream/metadata (already
    present in machine-readable debian/copyright).

 -- Nicolas Mora <nicolas@babelouest.org>  Sat, 27 Jun 2020 09:21:07 -0400

orcania (2.1.0-3) experimental; urgency=medium

  * d/liborcania-dev.doc-base: fix Author
  * d/copyright: fix uploader e-mail address
  * d/control: replace debhelper with debhelper-compat
  * d/control: set compat version to 13
  * d/control: add Rules-Requires-Root: no

 -- Nicolas Mora <nicolas@babelouest.org>  Wed, 03 Jun 2020 07:10:12 -0400

orcania (2.1.0-2) experimental; urgency=medium

  * d/rules: generate doc using doxygen
  * d/tests/unit-test: add pointer_list_test
  * d/liborcania-dev.docs: install documentation

 -- Nicolas Mora <nicolas@babelouest.org>  Thu, 02 Apr 2020 21:44:30 -0400

orcania (2.1.0-1) experimental; urgency=medium

  * debian/control: New upstream release
  * debian/control: Remove libjansson dependency
  * debian/control: bump standard to 4.5.0 (no changes)
  * debian/copyright: fix copyright issues

 -- Nicolas Mora <nicolas@babelouest.org>  Wed, 19 Feb 2020 08:02:12 -0500

orcania (1.2.9-6) unstable; urgency=medium

  * debian/control: Add Multi-Arch: same

 -- Nicolas Mora <nicolas@babelouest.org>  Tue, 08 Jan 2019 20:30:43 -0500

=== debian/control ===
Source: orcania
Section: devel
Priority: optional
Maintainer: Debian IoT Maintainers <debian-iot-maintainers@lists.alioth.debian.org>
Uploaders: Thorsten Alteholz <debian@alteholz.de>
          , Nicolas Mora <babelouest@debian.org>
Build-Depends: debhelper-compat (= 13)
	, autopkgtest (>= 5.6~)
	, cmake
	, check
	, doxygen
  , pkg-config
Standards-Version: 4.5.1
Homepage: https://github.com/babelouest/orcania
Vcs-Browser: https://salsa.debian.org/debian-iot-team/oauth2/orcania.git
Vcs-Git: https://salsa.debian.org/debian-iot-team/oauth2/orcania.git
Rules-Requires-Root: no

Package: liborcania2.1
Replaces: liborcania1.2
Breaks: liborcania1.2
Architecture: any
Multi-Arch: same
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: library for angharad programs
 Different functions for different purposes but that can be shared
 between other projects
 .
 Basically these are used for other programs in the anghard project.

Package: liborcania-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: liborcania2.1 (= ${binary:Version})
	, ${misc:Depends}
Description: library for angharad programs, development files
 Different functions for different purposes but that can be shared
 between other projects
 .
 Basically these are used for other programs in the anghard project.
 .
 This package contains the development files.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@ --buildsystem=cmake --builddirectory=build

override_dh_auto_configure:
	dh_auto_configure -- $(ARGS) -DBUILD_ORCANIA_TESTING=on\
	                             -DINSTALL_HEADER=on\
	                             --no-warn-unused-cli

override_dh_auto_build:
	doxygen doc/doxygen.cfg
	dh_auto_build --

## orcania 2.2.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -29,7 +29,7 @@
 set(PROJECT_HOMEPAGE_URL "https://github.com/babelouest/orcania/")
 set(PROJECT_BUGREPORT_PATH "https://github.com/babelouest/orcania/issues")
 set(LIBRARY_VERSION_MAJOR "2")
-set(LIBRARY_VERSION_MINOR "1")
+set(LIBRARY_VERSION_MINOR "2")
 set(LIBRARY_VERSION_PATCH "1")
 set(LIBS "-lm")
 
@@ -84,6 +84,7 @@
 
 set(INC_DIR ${CMAKE_CURRENT_SOURCE_DIR}/include)
 set(SRC_DIR ${CMAKE_CURRENT_SOURCE_DIR}/src)
+set(BASE64URL_DIR ${CMAKE_CURRENT_SOURCE_DIR}/tools/base64url)
 
 include_directories(${INC_DIR})
 
@@ -156,6 +157,19 @@
     endif ()
 endif ()
 
+# build base64url
+
+option(BUILD_BASE64URL "Build base64url application." ON)
+
+if (BUILD_BASE64URL)
+    add_executable(base64url ${BASE64URL_DIR}/base64url.c ${INC_DIR}/orcania.h ${PROJECT_BINARY_DIR}/orcania-cfg.h)
+    set_target_properties(base64url PROPERTIES SKIP_BUILD_RPATH TRUE)
+    add_dependencies(base64url orcania)
+    target_link_libraries(base64url orcania ${LIBS})
+    install(TARGETS base64url RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
+    install(FILES ${BASE64URL_DIR}/base64url.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1 COMPONENT runtime)
+endif ()
+
 # tests
 
 option(BUILD_ORCANIA_TESTING "Build the testing tree." OFF) # because we do not use include(CTest)
@@ -293,8 +307,9 @@
         COMMAND ${CMAKE_MAKE_PROGRAM} package_source)
 
 message(STATUS "Force inline implementation of strstr: ${WITH_STRSTR}")
-message(STATUS "Build static library: ${BUILD_STATIC}")
-message(STATUS "Build testing tree: ${BUILD_ULFIUS_TESTING}")
-message(STATUS "Install the header files: ${INSTALL_HEADER}")
-message(STATUS "Build RPM package: ${BUILD_RPM}")
-message(STATUS "Build documentation: ${BUILD_ORCANIA_DOCUMENTATION}")
+message(STATUS "Build static library:                  ${BUILD_STATIC}")
+message(STATUS "Build testing tree:                    ${BUILD_ORCANIA_TESTING}")
+message(STATUS "Install the header files:              ${INSTALL_HEADER}")
+message(STATUS "Build RPM package:                     ${BUILD_RPM}")
+message(STATUS "Build documentation:                   ${BUILD_ORCANIA_DOCUMENTATION}")
+message(STATUS "Build base64url application:           ${BUILD_BASE64URL}")

=== Makefile ===
--- 
+++ 
@@ -21,29 +21,36 @@
 
 LIBORCANIA_LOCATION=./src
 TESTS_LOCATION=./test
+BASE64URL_LOCATION=./tools/base64url/
 
 all: target
 
 target:
 	cd $(LIBORCANIA_LOCATION) && $(MAKE) $*
+	cd $(BASE64URL_LOCATION) && $(MAKE) $*
 
 debug:
 	cd $(LIBORCANIA_LOCATION) && $(MAKE) debug $*
+	cd $(BASE64URL_LOCATION) && $(MAKE) debug $*
 
 clean:
 	cd $(LIBORCANIA_LOCATION) && $(MAKE) clean
 	cd $(TESTS_LOCATION) && $(MAKE) clean
+	cd $(BASE64URL_LOCATION) && $(MAKE) clean
 	rm -rf doc/html/ doc/man/
 
 check:
 	cd $(LIBORCANIA_LOCATION) && $(MAKE) debug $*
 	cd $(TESTS_LOCATION) && $(MAKE) test $*
+	cd $(BASE64URL_LOCATION) && $(MAKE) test $*
 
 install:
 	cd $(LIBORCANIA_LOCATION) && $(MAKE) install $*
+	cd $(BASE64URL_LOCATION) && $(MAKE) install $*
 
 uninstall:
 	cd $(LIBORCANIA_LOCATION) && $(MAKE) uninstall $*
+	cd $(BASE64URL_LOCATION) && $(MAKE) uninstall $*
 
 doxygen:
 	doxygen doc/doxygen.cfg

=== src/Makefile ===
--- 
+++ 
@@ -33,10 +33,11 @@
 CFLAGS+=-c -fPIC -Wall -Werror -Wextra -I$(ORCANIA_INCLUDE) -D_REENTRANT $(ADDITIONALFLAGS) $(CPPFLAGS)
 OUTPUT=liborcania.so
 VERSION_MAJOR=2
-VERSION_MINOR=1
+VERSION_MINOR=2
 VERSION_PATCH=1
 OBJECTS=orcania.o memory.o base64.o
-LIBS=-lc -lm
+LIBSDEP=-lm
+LIBS=-lc
 
 SONAME = -soname
 ifeq ($(shell uname -s),Darwin)
@@ -79,12 +80,13 @@
 	@sed -i -e 's/@LIBRARY_VERSION@/$(VERSION_MAJOR).$(VERSION_MINOR).$(VERSION_PATCH)/g' $(PKGCONFIG_FILE)
 	@sed -i -e 's/@PKGCONF_REQ@/$(PKGCONF_REQ)/g' $(PKGCONFIG_FILE)
 	@sed -i -e 's/@PKGCONF_REQ_PRIVATE@/$(PKGCONF_REQ_PRIVATE)/g' $(PKGCONFIG_FILE)
+	@sed -i -e 's/@LIB_STATIC@/$(LIB_STATIC)/g' $(PKGCONFIG_FILE)
 
-liborcania.so: $(OBJECTS)
-	$(CC) -shared -fPIC -Wl,$(SONAME),$(OUTPUT) -o $(OUTPUT).$(VERSION_MAJOR).$(VERSION_MINOR).$(VERSION_PATCH) $(OBJECTS) $(LIBS) $(LDFLAGS)
+liborcania.so: $(OBJECTS) $(PKGCONFIG_FILE)
+	$(CC) -shared -fPIC -Wl,$(SONAME),$(OUTPUT) -o $(OUTPUT).$(VERSION_MAJOR).$(VERSION_MINOR).$(VERSION_PATCH) $(OBJECTS) $(LIBS) $(LIBSDEP) $(LDFLAGS)
 	ln -sf $(OUTPUT).$(VERSION_MAJOR).$(VERSION_MINOR).$(VERSION_PATCH) $(OUTPUT)
 
-liborcania.a: $(OBJECTS)
+liborcania.a: $(OBJECTS) $(PKGCONFIG_FILE)
 	ar rcs liborcania.a $(OBJECTS)
 
 %.o: %.c $(CONFIG_FILE) ../include/orcania.h
@@ -93,9 +95,9 @@
 clean:
 	rm -f *.o *.so *.a $(OUTPUT) $(OUTPUT).* $(CONFIG_FILE) $(PKGCONFIG_FILE)
 
-install: all $(PKGCONFIG_FILE)
+install: all
 	install $(OUTPUT).$(VERSION_MAJOR).$(VERSION_MINOR).$(VERSION_PATCH) $(DESTDIR)/lib
-	mkdir -p $(DESTDIR)/lib/pkgconfig/
+	mkdir -p $(DESTDIR)/lib/pkgconfig/ $(DESTDIR)/include
 	install -m644 $(PKGCONFIG_FILE) $(DESTDIR)/lib/pkgconfig/
 	install -m644 ../include/orcania.h $(DESTDIR)/include
 	install -m644 $(CONFIG_FILE) $(DESTDIR)/include
@@ -103,6 +105,7 @@
 
 static-install: static
 	install liborcania.a $(DESTDIR)/lib
+	mkdir -p $(DESTDIR)/lib/pkgconfig/ $(DESTDIR)/include
 	install -m644 $(PKGCONFIG_FILE) $(DESTDIR)/lib/pkgconfig
 	install -m644 ../include/orcania.h $(DESTDIR)/include
 	install -m644 $(CONFIG_FILE) $(DESTDIR)/include
@@ -126,6 +129,10 @@
 
 static-debug: liborcania.a
 
+static-debug: LIB_STATIC=$(LIBSDEP)
+
 static: ADDITIONALFLAGS=-O3
 
 static: liborcania.a
+
+static: LIB_STATIC=$(LIBSDEP)

=== test/Makefile ===
#
# Public domain, no copyright. Use at your own risk.
#

CC=gcc
CFLAGS+=-Wall -D_REENTRANT -DDEBUG -g -O0 -I$(INCLUDE_LOCATION) $(CPPFLAGS)
ORCANIA_LOCATION=../src
INCLUDE_LOCATION=../include
ORCANIA_LIBRARY=$(ORCANIA_LOCATION)/liborcania.so
LDFLAGS=-lc -lorcania $(shell pkg-config --libs check) -L$(ORCANIA_LOCATION)
VALGRIND_COMMAND=valgrind --tool=memcheck --leak-check=full --show-leak-kinds=all
TARGET=str_test split_test memory_test pointer_list_test
VERBOSE=0
MEMCHECK=0

all: test

clean:
	rm -f *.o $(TARGET) *.log valgrind-*.txt

$(ORCANIA_LIBRARY): $(ORCANIA_LOCATION)/orcania.c $(ORCANIA_LOCATION)/memory.c $(ORCANIA_LOCATION)/base64.c
	cd $(ORCANIA_LOCATION) && $(MAKE) debug  $*

%: %.c
	$(CC) $(CFLAGS) $^ -o $@ $(LDFLAGS)

test: $(ORCANIA_LIBRARY) $(TARGET) test_str_test test_split_test test_memory_test test_pointer_list_test

check: test

test_%: % $(ORCANIA_LIBRARY)
	@if [ "$(VERBOSE)" = "0" ] && [ "$(MEMCHECK)" = "0" ]; then \
		LD_LIBRARY_PATH=$(ORCANIA_LOCATION):${LD_LIBRARY_PATH} ./run_test.sh ./$^; \
	elif [ "$(MEMCHECK)" = "0" ]; then \
		LD_LIBRARY_PATH=$(ORCANIA_LOCATION):${LD_LIBRARY_PATH} ./$^ ; \
	else \
		CK_FORK=no LD_LIBRARY_PATH=$(ORCANIA_LOCATION):${LD_LIBRARY_PATH} $(VALGRIND_COMMAND) ./$^ 2>valgrind-$@.txt; \
	fi

=== tools/base64url/Makefile ===
#
# base64url: Base64Url encode or decode FILE, or standard input, to standard output.
#
# Makefile used to build the software
#
# Copyright 2021 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU GENERAL PUBLIC LICENSE
# License as published by the Free Software Foundation;
# version 3 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU GENERAL PUBLIC LICENSE for more details.
#
# You should have received a copy of the GNU General Public
# License along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
CC=gcc
ORCANIA_INCLUDE=../../include
ORCANIA_LOCATION=../../src
DESTDIR=/usr/local

CFLAGS+=-Wall -I$(ORCANIA_INCLUDE) $(ADDITIONALFLAGS) $(CPPFLAGS)
LIBS=-lc -lorcania -L$(ORCANIA_LOCATION)
ORCANIA_LIBRARY=../../src/liborcania.so
VALGRIND_COMMAND=valgrind --tool=memcheck --leak-check=full --show-leak-kinds=all --track-origins=yes

all: base64url

all: ADDITIONALFLAGS= -O3

clean:
	rm -f *.o base64url *.b64

debug: base64url

debug: ADDITIONALFLAGS=-DDEBUG -g -O0

$(ORCANIA_LIBRARY):
	cd $(ORCANIA_LOCATION) && $(MAKE) debug

base64url: $(ORCANIA_LIBRARY) base64url.c
	$(CC) -o base64url $(CFLAGS) base64url.c $(LIBS)

install: base64url
	mkdir -p $(DESTDIR)/bin $(DESTDIR)/man/man1/
	install -m755 base64url $(DESTDIR)/bin
	install -m644 base64url.1 $(DESTDIR)/man/man1/

uninstall:
	rm -f $(DESTDIR)/bin/base64url

manpage: base64url
	help2man ./base64url -s 1 -n "Base64Url encode or decode FILE, or standard input, to standard output." > base64url.1

test: base64url
	echo plop | LD_LIBRARY_PATH=$(ORCANIA_LOCATION) $(VALGRIND_COMMAND) ./base64url
	LD_LIBRARY_PATH=$(ORCANIA_LOCATION) $(VALGRIND_COMMAND) ./base64url -f README.md
	LD_LIBRARY_PATH=$(ORCANIA_LOCATION) $(VALGRIND_COMMAND) ./base64url -f error || true
	echo ";error;" | LD_LIBRARY_PATH=$(ORCANIA_LOCATION) $(VALGRIND_COMMAND) ./base64url -d || true
	echo Z3J1dAo | LD_LIBRARY_PATH=$(ORCANIA_LOCATION) $(VALGRIND_COMMAND) ./base64url -d
	echo ZuJ1dAo | LD_LIBRARY_PATH=$(ORCANIA_LOCATION) $(VALGRIND_COMMAND) ./base64url -d -i
	echo plop | LD_LIBRARY_PATH=$(ORCANIA_LOCATION) $(VALGRIND_COMMAND) ./base64url -w 2

=== debian/changelog ===
orcania (2.2.1-1) unstable; urgency=medium

  * New upstream release
  * d/rules: do not build base64url, conflicted name with package basez
  * d/copyright: removed obsolete file mention

 -- Nicolas Mora <babelouest@debian.org>  Mon, 06 Sep 2021 19:32:08 -0400

=== debian/control ===
--- 
+++ 
@@ -16,7 +16,7 @@
 Vcs-Git: https://salsa.debian.org/debian-iot-team/oauth2/orcania.git
 Rules-Requires-Root: no
 
-Package: liborcania2.1
+Package: liborcania2.2
 Replaces: liborcania1.2
 Breaks: liborcania1.2
 Architecture: any
@@ -34,7 +34,7 @@
 Architecture: any
 Multi-Arch: same
 Section: libdevel
-Depends: liborcania2.1 (= ${binary:Version})
+Depends: liborcania2.2 (= ${binary:Version})
 	, ${misc:Depends}
 Description: library for angharad programs, development files
  Different functions for different purposes but that can be shared

=== debian/tests/control ===
Tests: unit-test
Depends: @, gcc, libc-dev, check, libsubunit-dev, pkg-config

## orcania 2.3.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 # CMake file used to build all programs
 #
 # Copyright 2018 Silvio Clecio <silvioprog@gmail.com>
-# Copyright 2018-2020 Nicolas Mora <mail@babelouest.org>
+# Copyright 2018-2022 Nicolas Mora <mail@babelouest.org>
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the MIT License
@@ -29,8 +29,8 @@
 set(PROJECT_HOMEPAGE_URL "https://github.com/babelouest/orcania/")
 set(PROJECT_BUGREPORT_PATH "https://github.com/babelouest/orcania/issues")
 set(LIBRARY_VERSION_MAJOR "2")
-set(LIBRARY_VERSION_MINOR "2")
-set(LIBRARY_VERSION_PATCH "1")
+set(LIBRARY_VERSION_MINOR "3")
+set(LIBRARY_VERSION_PATCH "0")
 set(LIBS "-lm")
 
 set(PROJECT_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
@@ -60,7 +60,8 @@
 
 # cmake modules
 
-set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake-modules)
+set(O_CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake-modules)
+list(APPEND CMAKE_MODULE_PATH "${O_CMAKE_MODULE_PATH}")
 
 include(GNUInstallDirs)
 include(CheckSymbolExists)
@@ -207,7 +208,7 @@
                 pointer_list_test)
 
         configure_file(
-                "${CMAKE_MODULE_PATH}/CTestCustom.cmake.in"
+                "${O_CMAKE_MODULE_PATH}/CTestCustom.cmake.in"
                 "${CMAKE_CURRENT_BINARY_DIR}/CTestCustom.cmake"
                 @ONLY)
 
@@ -224,6 +225,18 @@
 
 # install target
 
+if(IS_ABSOLUTE "${CMAKE_INSTALL_INCLUDEDIR}")
+  set(PKGCONFIG_TARGET_INCLUDES "${CMAKE_INSTALL_INCLUDEDIR}")
+else()
+  set(PKGCONFIG_TARGET_INCLUDES "\${prefix}/${CMAKE_INSTALL_INCLUDEDIR}")
+endif()
+
+if(IS_ABSOLUTE "${CMAKE_INSTALL_LIBDIR}")
+  set(PKGCONFIG_TARGET_LIBDIR "${CMAKE_INSTALL_LIBDIR}")
+else()
+  set(PKGCONFIG_TARGET_LIBDIR "\${prefix}/${CMAKE_INSTALL_LIBDIR}")
+endif()
+
 option(INSTALL_HEADER "Install the header files" ON) # Install orcania.h or not
 
 configure_file(liborcania.pc.in liborcania.pc @ONLY)
@@ -253,7 +266,7 @@
 
 if (NOT TARGET uninstall)
     configure_file(
-            "${CMAKE_MODULE_PATH}/CMakeUninstall.cmake.in"
+            "${O_CMAKE_MODULE_PATH}/CMakeUninstall.cmake.in"
             "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
             IMMEDIATE @ONLY)
     add_custom_target(uninstall

=== Makefile ===
--- 
+++ 
@@ -3,7 +3,7 @@
 #
 # Makefile used to build all programs
 #
-# Copyright 2017-2020 Nicolas Mora <mail@babelouest.org>
+# Copyright 2017-2022 Nicolas Mora <mail@babelouest.org>
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU Lesser General Public License

=== src/Makefile ===
--- 
+++ 
@@ -3,7 +3,7 @@
 #
 # Makefile used to build the software
 #
-# Copyright 2014-2020 Nicolas Mora <mail@babelouest.org>
+# Copyright 2014-2022 Nicolas Mora <mail@babelouest.org>
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU Lesser General Public License
@@ -33,8 +33,8 @@
 CFLAGS+=-c -fPIC -Wall -Werror -Wextra -I$(ORCANIA_INCLUDE) -D_REENTRANT $(ADDITIONALFLAGS) $(CPPFLAGS)
 OUTPUT=liborcania.so
 VERSION_MAJOR=2
-VERSION_MINOR=2
-VERSION_PATCH=1
+VERSION_MINOR=3
+VERSION_PATCH=0
 OBJECTS=orcania.o memory.o base64.o
 LIBSDEP=-lm
 LIBS=-lc
@@ -72,8 +72,8 @@
 	@cp $(PKGCONFIG_TEMPLATE) $(PKGCONFIG_FILE)
 	@echo Pkgconfig file $(PKGCONFIG_FILE) generated
 	@sed -i -e 's#@CMAKE_INSTALL_PREFIX@#$(DESTDIR)#g' $(PKGCONFIG_FILE)
-	@sed -i -e 's/@CMAKE_INSTALL_LIBDIR@/lib/g' $(PKGCONFIG_FILE)
-	@sed -i -e 's/@CMAKE_INSTALL_INCLUDEDIR@/include/g' $(PKGCONFIG_FILE)
+	@sed -i -e 's#@PKGCONFIG_TARGET_LIBDIR@#$${prefix}/lib#g' $(PKGCONFIG_FILE)
+	@sed -i -e 's#@PKGCONFIG_TARGET_INCLUDES@#$${prefix}/include#g' $(PKGCONFIG_FILE)
 	@sed -i -e 's/@PROJECT_NAME@/$(PROJECT_NAME)/g' $(PKGCONFIG_FILE)
 	@sed -i -e 's/@PROJECT_DESCRIPTION@/$(PROJECT_DESCRIPTION)/g' $(PKGCONFIG_FILE)
 	@sed -i -e 's|@PROJECT_BUGREPORT_PATH@|$(PROJECT_BUGREPORT_PATH)|g' $(PKGCONFIG_FILE)

=== debian/changelog ===
orcania (2.3.0-2) unstable; urgency=medium

  * Reupload to unstable as source package

 -- Nicolas Mora <babelouest@debian.org>  Thu, 02 Jun 2022 18:52:38 -0400

orcania (2.3.0-1) unstable; urgency=medium

  * New upstream release
  * d/liborcania2.2.symbols: Set correct version for o_strnullempty
  * d/copyright: add tools/base64url/*

 -- Nicolas Mora <babelouest@debian.org>  Mon, 30 May 2022 07:01:07 -0400

orcania (2.2.2-3) unstable; urgency=medium

  * d/control: Add Breaks libiddawc1.1 (<= 1.1.1)
  * d/control: unify packages description

 -- Nicolas Mora <babelouest@debian.org>  Mon, 18 Apr 2022 16:27:41 -0400

orcania (2.2.2-2) unstable; urgency=medium

  * d/u/metadata: Add metdata
  * d/control: Update packages description

 -- Nicolas Mora <babelouest@debian.org>  Sun, 17 Apr 2022 08:30:03 -0400

orcania (2.2.2-1) unstable; urgency=medium

  * New upstream release
  * d/copyright: update years
  * d/control: Update Standards-Version to 4.6.0 (no change)
  * d/liborcania2.2.symbols: Add symbol o_strnullempty

 -- Nicolas Mora <babelouest@debian.org>  Mon, 11 Apr 2022 07:48:56 -0400

=== debian/control ===
Source: orcania
Section: devel
Priority: optional
Maintainer: Debian IoT Maintainers <debian-iot-maintainers@lists.alioth.debian.org>
Uploaders: Thorsten Alteholz <debian@alteholz.de>
          , Nicolas Mora <babelouest@debian.org>
Build-Depends: debhelper-compat (= 13)
             , autopkgtest (>= 5.6~)
             , cmake
             , check
             , doxygen
             , pkg-config
Standards-Version: 4.6.0
Homepage: https://github.com/babelouest/orcania
Vcs-Browser: https://salsa.debian.org/debian-iot-team/oauth2/orcania.git
Vcs-Git: https://salsa.debian.org/debian-iot-team/oauth2/orcania.git
Rules-Requires-Root: no

Package: liborcania2.3
Replaces: liborcania1.2
Breaks: liborcania1.2, libiddawc1.1 (<= 1.1.1)
Architecture: any
Multi-Arch: same
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: library for angharad programs
 Potluck with different functions for different purposes that can
 be shared among C programs

Package: liborcania-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: liborcania2.3 (= ${binary:Version})
	, ${misc:Depends}
Description: library for angharad programs, development files
 Potluck with different functions for different purposes that can
 be shared among C programs
 .
 This package contains the development files.
